package com.titan.clients;

import com.titan.travelagent.TravelAgentRemote;
import com.titan.domain.Cabin;

import javax.naming.InitialContext;
import javax.naming.Context;
import javax.naming.NamingException;

import javax.rmi.PortableRemoteObject;

public class Client_1 
{
    public static void main(String [] args) 
    {
        try 
        {
            Context jndiContext = getInitialContext();
            Object ref = jndiContext.lookup("TravelAgentBean/remote");
            TravelAgentRemote dao = (TravelAgentRemote)ref;

            Cabin noCabin = dao.findCabin(1);
            System.out.println("adna kajuta nie moe by reprezentowana przez null: " + noCabin);

            Cabin cabin_1 = new Cabin();
            cabin_1.setId(1);
            cabin_1.setName("Kajuta luksusowa");
            cabin_1.setDeckLevel(1);
            cabin_1.setShipId(1);
            cabin_1.setBedCount(3);

            dao.createCabin(cabin_1);

            Cabin cabin_2 = dao.findCabin(1);
            System.out.println(cabin_2.getName());
            System.out.println(cabin_2.getDeckLevel());
            System.out.println(cabin_2.getShipId());
            System.out.println(cabin_2.getBedCount());

	    System.out.println("Aktualizacja odczonego egzemplarza encji Cabin z wykorzystaniem nowej liczby ek (rwnej 4).");
	    cabin_2.setBedCount(4);
	    dao.updateCabin(cabin_2);

	    System.out.println("Odnajdujemy kajut, aby sprawdzi, czy zostaa zaktualizowana przez metod merge().");
            Cabin cabin_3 = dao.findCabin(1);
	    System.out.println("Nowa liczba ek wynosi: " + cabin_3.getBedCount());
        } 
        catch (javax.naming.NamingException ne)
        {
	    ne.printStackTrace();
	}
    }

    public static Context getInitialContext() 
        throws javax.naming.NamingException 
    {
        return new javax.naming.InitialContext();
    }
}
